Index: branches/network/src/lib/network/network_stream.cc
===================================================================
--- branches/network/src/lib/network/network_stream.cc	(revision 7577)
+++ branches/network/src/lib/network/network_stream.cc	(revision 7578)
@@ -571,4 +571,5 @@
     assert( Converter::byteArrayToInt( buf + 2*INTSIZE, &fromState ) == INTSIZE );
     assert( Converter::byteArrayToInt( buf + 3*INTSIZE, &ackedState ) == INTSIZE );
+    offset = 4*INTSIZE;
 
     PRINTF(0)("got packet: %d, %d\n", length, packetLength);
@@ -584,6 +585,4 @@
       continue;
     }
-    
-    offset = 4*INTSIZE;
     
     while ( offset < length )
Index: branches/network/src/lib/network/synchronizeable.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable.cc	(revision 7578)
@@ -176,4 +176,5 @@
     if ( (*it)->getPriority() >= priorityTH || sizeIter == stateFrom->sizeList.end() )
     {
+      (*it)->debug();
       n = (*it)->writeToBuf( stateTo->data+i, stateTo->dataLength - i );
       stateTo->sizeList.push_back( n );
@@ -307,7 +308,5 @@
   
   this->varChangeHandler( changes );
-
-  assert( i == length );
-
+  
   return length;
 }
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_bool.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_bool.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_bool.cc	(revision 7578)
@@ -64,2 +64,12 @@
   return 1;
 }
+
+/**
+ * print out variable value
+ */
+void SynchronizeableBool::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: %d OUT: %d\n", name.c_str(), (int)*vPtrIn, (int)*vPtrOut );
+}
+
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_bool.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_bool.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_bool.h	(revision 7578)
@@ -24,4 +24,6 @@
     virtual bool hasStaticSize(){ return true; };
     
+    virtual void debug();
+    
   private:
     bool * vPtrIn;       //!< pointer to data (read)
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_float.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_float.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_float.cc	(revision 7578)
@@ -68,2 +68,12 @@
   return res;
 }
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableFloat::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: %f OUT: %f\n", name.c_str(), *vPtrIn, *vPtrOut );
+}
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_float.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_float.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_float.h	(revision 7578)
@@ -24,4 +24,6 @@
     virtual bool hasStaticSize(){ return true; };
     
+    virtual void debug();
+    
   private:
     float * vPtrIn;       //!< pointer to data (read)
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_int.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_int.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_int.cc	(revision 7578)
@@ -68,2 +68,12 @@
   return res;
 }
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableInt::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: %d OUT: %d\n", name.c_str(), *vPtrIn, *vPtrOut );
+}
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_int.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_int.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_int.h	(revision 7578)
@@ -24,5 +24,7 @@
     virtual bool hasStaticSize(){ return true; };
     
-  private:
+    virtual void debug();
+    
+  protected:
     int * vPtrIn;       //!< pointer to data (read)
     int * vPtrOut;      //!< pointer to data (write)
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_quaternion.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_quaternion.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_quaternion.cc	(revision 7578)
@@ -104,2 +104,12 @@
   return res;
 }
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableQuaternion::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: ((%f, %f, %f), %f) OUT: ((%f %f %f), %f)\n", name.c_str(), vPtrIn->v.x, vPtrIn->v.y, vPtrIn->v.z, vPtrIn->w, vPtrOut->v.x, vPtrOut->v.y, vPtrOut->v.z, vPtrOut->w );
+}
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_quaternion.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_quaternion.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_quaternion.h	(revision 7578)
@@ -26,4 +26,6 @@
     virtual bool hasStaticSize(){ return true; };
     
+    virtual void debug();
+    
   private:
     Quaternion * vPtrIn;       //!< pointer to data (read)
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_string.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_string.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_string.cc	(revision 7578)
@@ -66,2 +66,12 @@
   return res;
 }
+
+/**
+ * print out variable value
+ */
+void SynchronizeableString::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: '%s' OUT: '%s'\n", name.c_str(), vPtrIn->c_str(), vPtrOut->c_str() );
+}
+
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_string.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_string.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_string.h	(revision 7578)
@@ -30,4 +30,6 @@
     virtual int getSize(){ return vPtrIn->length()+INTSIZE; }
     
+    virtual void debug();
+    
   private:
     std::string * vPtrIn;       //!< pointer to data (read)
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_uint.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_uint.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_uint.cc	(revision 7578)
@@ -34,2 +34,10 @@
 
 
+/**
+ * print out variable value
+ */
+void SynchronizeableUInt::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: %u OUT: %u\n", name.c_str(), *vPtrIn, *vPtrOut );
+}
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_uint.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_uint.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_uint.h	(revision 7578)
@@ -14,4 +14,6 @@
     SynchronizeableUInt( unsigned int * ptrIn, unsigned int * ptrOut, std::string name, int permission = 0, int priority = 0 );
     virtual ~SynchronizeableUInt();
+    
+    virtual void debug();
 
 };
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_var.h	(revision 7578)
@@ -85,4 +85,9 @@
      */
     inline void resetPriority() { this->priority = this->realPriority; }
+    
+    /**
+     * print out variable value
+     */
+    virtual void debug() = 0;
 
 
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.cc
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.cc	(revision 7578)
@@ -97,2 +97,12 @@
   return res;
 }
+
+
+/**
+ * print out variable value
+ */
+void SynchronizeableVector::SynchronizeableVector::debug( )
+{
+  printf( "SYNCHRONIZEABLE_VAR: %s IN: (%f, %f, %f) OUT: (%f %f %f)\n", name.c_str(), vPtrIn->x, vPtrIn->y, vPtrIn->z, vPtrOut->x, vPtrOut->y, vPtrOut->z );
+}
+
Index: branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.h
===================================================================
--- branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 7577)
+++ branches/network/src/lib/network/synchronizeable_var/synchronizeable_vector.h	(revision 7578)
@@ -24,5 +24,7 @@
      * @return true if same size every time
      */
-    virtual bool hasStaticSize(){ return true; };
+    virtual bool hasStaticSize(){ return true; }
+    
+    virtual void debug();
     
   private: