Index: trunk/acinclude.m4
===================================================================
--- trunk/acinclude.m4	(revision 7664)
+++ trunk/acinclude.m4	(revision 7669)
@@ -85,5 +85,5 @@
     QT_INCLUDE_DIRECTORY=""
     QT_LIB_DIRECTORY=""
-
+    QT_BIN_DIRECTORY=""
 
     QT_COMMON_INCLUDE_DIRECTORIES="
@@ -95,4 +95,5 @@
       `ls -dr /opt/qt*/include         2>/dev/null`
       `ls -dr /Developer/qt*/include   2>/dev/null`
+      `ls -dr /c/Qt/*/include          2>/dev/null`
     "
 
@@ -101,14 +102,24 @@
       /usr/include
       `ls -dr /usr/lib/qt*             2>/dev/null`
-      `ls -dr /usr/lib/qt*             2>/dev/null`
       `ls -dr /usr/local/qt*/lib       2>/dev/null`
       `ls -dr /opt/qt*/lib             2>/dev/null`
       `ls -dr /Developer/qt*/lib       2>/dev/null`
+      `ls -dr /c/Qt/*/lib              2>/dev/null`
     "
 
-    ## Search in all IncludeDirectories for QT-includes
+    QT_COMMON_BIN_DIRECTORIES="
+      `ls -dr ${QT_PREFIX}/bin         2>/dev/null`
+      /usr/bin
+      `ls -dr /usr/bin/qt*             2>/dev/null`
+      `ls -dr /usr/local/qt*/bin       2>/dev/null`
+      `ls -dr /opt/qt*/bin             2>/dev/null`
+      `ls -dr /Developer/qt*/bin       2>/dev/null`
+      `ls -dr /c/Qt/*/bin              2>/dev/null`
+    "
+
+## Search in all IncludeDirectories for QT-includes
     for _include_directory in ${QT_COMMON_INCLUDE_DIRECTORIES}
     do
-      if test -e ${_include_directory}/Qt/QtCore ; then
+      if test -e ${_include_directory}/QtCore/QtCoreApplication ; then
         QT_INCLUDE_DIRECTORY=${_include_directory}
         break
@@ -124,5 +135,5 @@
     for _lib_directory in ${QT_COMMON_LIB_DIRECTORIES}
     do
-      if test -e ${_lib_directory}/libQtCore.so || test -e ${_lib_directory}/libQtCore.dll ; then
+      if test -e ${_lib_directory}/libQtCore.so || test -e ${_lib_directory}/libQtCore4.a ; then
         QT_LIB_DIRECTORY=${_lib_directory}
         break
@@ -133,4 +144,18 @@
     else
       AC_MSG_ERROR([Qt LIB not found])
+    fi
+
+## Search in all BINDirectories for QT-executables
+    for _bin_directory in ${QT_COMMON_BIN_DIRECTORIES}
+    do
+      if test -e ${_bin_directory}/moc || test -e  ${_bin_directory}/moc.exe ; then
+        QT_BIN_DIRECTORY=${_bin_directory}
+        break
+      fi
+    done
+    if test -n ${QT_BIN_DIRECTORY} ; then
+	echo "Qt-Bin Directory is: ${QT_BIN_DIRECTORY}"
+    else
+	QT_BIN_DIRECTORY=${QT_PREFIX}/bin
     fi
 
@@ -139,5 +164,4 @@
     QT_CXXFLAGS="-I${QT_INCLUDE_DIRECTORY}"
     LDFLAGS="${LDFLAGS} -L${QT_LIB_DIRECTORY} -Wl,-rpath -Wl,${QT_LIB_DIRECTORY}"
-    QT_BIN_DIR="${QT_PREFIX}/bin"
 
     CACHED_CPPFLAG=${CPPFLAGS}
@@ -173,4 +197,5 @@
     echo "QT_CXXFLAGS = ${QT_CXXFLAGS}"
     echo "QT_LD_FLAGS = ${QT_LDFLAGS}"
+    echo "QT_BIN_DIRECTORY = ${QT_BIN_DIRECTORY}"
 
     AC_SUBST([QT_LIBS])
@@ -181,5 +206,5 @@
     # QT - MOC #
     #----------#
-    AC_PATH_PROG([QT_MOC], [moc], [no], ["${QT_BIN_DIR}:${PATH}"])
+    AC_PATH_PROG([QT_MOC], [moc], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
       if test x${QT_MOC} = xno ; then
         AC_MSG_ERROR([QT MOC not found])
@@ -187,5 +212,5 @@
     AC_SUBST([QT_MOC])
 
-    AC_PATH_PROG([QT_UIC], [uic], [no], ["${QT_BIN_DIR}:${PATH}"])
+    AC_PATH_PROG([QT_UIC], [uic], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
  #     if test x${QT_UIC} = xno ; then
  #       AC_MSG_WARN([QT UIC not found])
@@ -193,5 +218,5 @@
     AC_SUBST([QT_UIC])
 
-    AC_PATH_PROG([QT_RCC], [rcc], [no], ["${QT_BIN_DIR}:${PATH}"])
+    AC_PATH_PROG([QT_RCC], [rcc], [no], ["${QT_BIN_DIRECTORY}:${PATH}"])
 #      if test x${QT_RCC} = xno ; then
 #        AC_MSG_WARN([QT RCC not found])
Index: trunk/configure.ac
===================================================================
--- trunk/configure.ac	(revision 7664)
+++ trunk/configure.ac	(revision 7669)
@@ -573,5 +573,5 @@
 # QT #
 #----#
-AX_CHECK_QT([${QT_PREFIX}], [QtCore],, [http://www.trolltech.com])
+AX_CHECK_QT([${QT_PREFIX}], [QtCore QtCore4],, [http://www.trolltech.com])
 if test x$have_qt = xno ; then
     WITH_QT=no