Index: code/trunk/data/levels/The Time Machine.oxw
===================================================================
--- code/trunk/data/levels/The Time Machine.oxw	(revision 7655)
+++ code/trunk/data/levels/The Time Machine.oxw	(revision 7673)
@@ -2,5 +2,5 @@
  name = "The Time Machine"
  description = "A simple level. The only goal is to defeat as much enemies as you can."
- tags = ""
+ tags = "singleplayer"
 />
 
@@ -43,5 +43,5 @@
       <BlinkingBillboard position="17,-1.5,0" material="Examples/Flare" colour="1.0, 0.5, 0.3" amplitude=0.1 frequency=0.5 quadratic=1 />
       <BlinkingBillboard position="-17,-1.5,0" material="Examples/Flare" colour="0.5, 1.0, 0.3" amplitude=0.1 frequency=0.5 phase=180 quadratic=1 />
-      <DistanceTriggerBeacon name="PlayerDistanceTrigger" /> <!--added DistanceTrigger-->
+      <DistanceTriggerBeacon name="PlayerDistanceTrigger" /> <!--added DistanceTriggerBeacon-->
     </attached>
     <collisionShapes>
@@ -61,8 +61,4 @@
 <!--*****************************************************************************************************************************************************************************************-->
 
-
-
-
-<!--CREATING SPAWNPOINTS______________________________________________________________________________________________________________________________________________________________OK-->
 <Level
     name="The Time Machine"
@@ -70,7 +66,7 @@
     gametype=TeamDeathmatch
 >
-  <templates>
-    <Template link=lodtemplate_default />
-  </templates>
+    <templates>
+        <Template link=lodtemplate_default />
+    </templates>
     <Scene
         ambientlight="0.8,0.8,0.8"
@@ -80,6 +76,7 @@
         <Light type=directional position="0,0,0" direction="0, 0, 0" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 1.0, 0.9" />
 
+<!--CREATING SPAWNPOINTS_____________________________________________________________________________________________________________________________________________________________________-->
 <?lua for i=0,4,1 do
-x=500
+    x=500
 ?>    
 
@@ -89,5 +86,5 @@
 
 <!--enemy spaceship spawnpoint-->
-        <!-- TeamSpawnPoint team=1 position="4000,0,<?lua print(i*x-1000) ?>" lookat="-5000,0,<?lua print(i*x-1000) ?>" spawnclass=SpaceShip pawndesign=spaceshippirate /-->
+        <!--TeamSpawnPoint team=1 position="4000,0,<?lua print(i*x-1000) ?>" lookat="-5000,0,<?lua print(i*x-1000) ?>" spawnclass=SpaceShip pawndesign=spaceshippirate /-->
 <?lua end ?>
 
@@ -95,5 +92,5 @@
 
 
-<!--Triggers (used for the Time Machine effect)_________________________________________________________________________________________________________________________partially working-->
+<!--Triggers (used for the Time Machine effect)___________________________________________________________________________________________________________________________________________-->
     
         <!--TRIGGERS IF THE PLAYERS REACHES THE "TIME MACHINE"-->
@@ -144,5 +141,5 @@
         </Trigger>
 
-        <!-- This Trigger is true iff the player is in the TimeMachine and has shot another player -->
+        <!-- This Trigger is true if the player is in the TimeMachine and has shot another player -->
         <EventTrigger name=trigger2 switch=true >
             <events>
@@ -175,13 +172,13 @@
 <!--Triggers (used for the Time Machine effect)_____________________________________________________________________________________________________________________________________________-->
 
-<!--Creating Spaceships___________________________________________________________________________________________________________________________________________________________________OK-->
+<!--Creating Spaceships_____________________________________________________________________________________________________________________________________________________________________-->
     
 <?lua for i=0,5,1 do 
-y=math.random(-500,500)
-z=math.random(-1000,1000)
-y2=math.random(-500,500)
-z2=math.random(-1000,1000)
-health=230
-addh=100
+    y=math.random(-500,500)
+    z=math.random(-1000,1000)
+    y2=math.random(-500,500)
+    z2=math.random(-1000,1000)
+    health=230
+    addh=100
 ?>
     
@@ -265,5 +262,5 @@
 <?lua end ?>
 
-<!--Creating Spaceships_____END___________________________________________________________________________________________________________________________________________________________OK-->
+<!--Creating Spaceships_____END_____________________________________________________________________________________________________________________________________________________________-->
 
 <!--BILLBOARD IN THE MIDDLE OF THE BATTLEFIELD-->
@@ -320,4 +317,5 @@
                                 <MovableEntity position="<?lua print(1500-3000*i) ?>,0,0">
                                     <attached>
+                                        <ForceField position="0,0,0" mode="sphere" diameter=500 velocity=100000 />
                                         <Billboard position="0,0,0" material="Examples/Flare" colour="1.0,1.0,1.0" scale=0.3/>
                                         <MovableEntity    position="0,0,0" rotationaxis="1,1,0" rotationrate=-255 >
@@ -367,4 +365,5 @@
                                 <MovableEntity position="0,<?lua print(1500-3000*i) ?>,0">
                                     <attached>
+                                        <ForceField position="0,0,0" mode="sphere" diameter=500 velocity=100000 />
                                         <Billboard position="0,0,0" material="Examples/Flare" colour="1.0,1.0,1.0" scale=0.3/>
                                         <MovableEntity    position="0,0,0" rotationaxis="1,1,0" rotationrate=-255 >
@@ -414,4 +413,5 @@
                                 <MovableEntity position="<?lua print(1000-2000*i) ?>,<?lua print(-1000+2000*i) ?>,0">
                                     <attached>
+                                        <ForceField position="0,0,0" mode="sphere" diameter=500 velocity=100000 />
                                         <Billboard position="0,0,0" material="Examples/Flare" colour="1.0,1.0,1.0" scale=0.3/>
                                         <MovableEntity    position="0,0,0" rotationaxis="1,1,0" rotationrate=-255 >
@@ -461,4 +461,5 @@
                                 <MovableEntity position="<?lua print(1000-2000*i) ?>,<?lua print(-1000+2000*i) ?>,0">
                                     <attached>
+                                        <ForceField position="0,0,0" mode="sphere" diameter=500 velocity=100000 />
                                         <Billboard position="0,0,0" material="Examples/Flare" colour="1.0,1.0,1.0" scale=0.3/>
                                         <MovableEntity    position="0,0,0" rotationaxis="1,1,0" rotationrate=-255 >
@@ -508,4 +509,5 @@
                                 <MovableEntity position="<?lua print(1000-2000*i) ?>,0,<?lua print(-1000+2000*i) ?>">
                                     <attached>
+                                        <ForceField position="0,0,0" mode="sphere" diameter=500 velocity=100000 />
                                         <Billboard position="0,0,0" material="Examples/Flare" colour="1.0,1.0,1.0" scale=0.3/>
                                         <MovableEntity    position="0,0,0" rotationaxis="1,1,0" rotationrate=-255 >